commit eaf7eae8474ded19ec64022f71d1b9e610013d5c
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Fri Nov 7 09:37:04 2025 +0000

    Fix file open modes for Gnu/Hurd.  Bug 3175

diff --git a/src/src/exim_dbutil.c b/src/src/exim_dbutil.c
index cd98ff053..5065b6e9b 100644
--- a/src/src/exim_dbutil.c
+++ b/src/src/exim_dbutil.c
@@ -335,7 +335,7 @@ if (  asprintf(CSS &dirname, "%s/db", spool_directory) < 0
    || asprintf(CSS &filename, "%s/%s.lockfile", dirname, name) < 0)
   return NULL;
 
-dbblock->readonly = (flags & (O_WRONLY|O_RDWR)) == O_RDONLY;
+dbblock->readonly = (flags & O_ACCMODE) == O_RDONLY;
 dbblock->lockfd = -1;
 if (exim_lockfile_needed())
   {
diff --git a/src/src/hintsdb/hints_bdb.h b/src/src/hintsdb/hints_bdb.h
index 7285e85f9..85e8984ec 100644
--- a/src/src/hintsdb/hints_bdb.h
+++ b/src/src/hintsdb/hints_bdb.h
@@ -115,7 +115,7 @@ if (db_create(&b, dbp, 0) == 0)
   if (b->open(b, NULL, CS name, NULL,
 	      flags & O_CREAT ? DB_HASH : DB_UNKNOWN,
 	      flags & O_CREAT ? DB_CREATE
-	      : flags & (O_WRONLY|O_RDWR) ? 0 : DB_RDONLY,
+	      : (flags & O_ACCMODE) == O_RDONLY ? DB_RDONLY : 0,
 	      mode) == 0
 	  )
     return dbp;
@@ -266,7 +266,7 @@ return db_create(&dbp, NULL, 0) == 0
 	dbp->open(dbp, CS name, NULL,
 	  flags & O_CREAT ? DB_HASH : DB_UNKNOWN,
 	  flags & O_CREAT ? DB_CREATE
-	  : flags & (O_WRONLY|O_RDWR) ? 0 : DB_RDONLY,
+	  : (flags & O_ACCMODE) == O_RDONLY ? DB_RDONLY : 0,
 	  mode)
      ) == 0
   ? dbp : NULL;
diff --git a/src/src/hintsdb/hints_gdbm.h b/src/src/hintsdb/hints_gdbm.h
index 00c94a777..34df8c84f 100644
--- a/src/src/hintsdb/hints_gdbm.h
+++ b/src/src/hintsdb/hints_gdbm.h
@@ -58,7 +58,7 @@ if (dbp)
   dbp->lkey.dptr = NULL;
   dbp->gdbm = gdbm_open(CS name, 0,
     flags & O_CREAT ? GDBM_WRCREAT
-    : flags & (O_RDWR|O_WRONLY) ? GDBM_WRITER : GDBM_READER,
+    : (flags & O_ACCMODE) == O_RDONLY ? GDBM_READER : GDBM_WRITER,
     mode, 0);
   if (dbp->gdbm)
     return dbp;
diff --git a/src/src/hintsdb/hints_sqlite.h b/src/src/hintsdb/hints_sqlite.h
index 01906f839..40d50b8c0 100644
--- a/src/src/hintsdb/hints_sqlite.h
+++ b/src/src/hintsdb/hints_sqlite.h
@@ -45,7 +45,8 @@ exim_dbopen_multi__(const uschar * name, const uschar * dirname, int flags,
   unsigned mode)
 {
 EXIM_DB * dbp;
-int ret, sflags = flags & O_RDWR ? SQLITE_OPEN_READWRITE : SQLITE_OPEN_READONLY;
+int ret, sflags = (flags & O_ACCMODE) == O_RDONLY
+		  ? SQLITE_OPEN_READONLY : SQLITE_OPEN_READWRITE;
 
 if (flags & O_CREAT) sflags |= SQLITE_OPEN_CREATE;
 if ((ret = sqlite3_open_v2(CCS name, &dbp, sflags, NULL)) == SQLITE_OK)

